## hhvm 3.21.0+dfsg

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.7 FATAL_ERROR)

# This needs to be done before any languages are enabled or
# projects are created.
INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/CMake/VisualStudioToolset.cmake")

# includes
SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# package information
SET(PACKAGE_NAME      "hhvm")
SET(PACKAGE_VERSION   "3.20.0-dev")
SET(PACKAGE_STRING    "${PACKAGE_NAME} ${PACKAGE_VERSION}")
SET(PACKAGE_TARNAME   "${PACKAGE_NAME}-${PACKAGE_VERSION}")
SET(PACKAGE_BUGREPORT "https://github.com/facebook/hhvm/issues")

PROJECT(${PACKAGE_NAME} C CXX ASM)

include(HHVMProject)

if (MSVC)
  enable_language(ASM_MASM)
endif()

# Look for and apply patches to the third-party (and sub) repo.
file(GLOB PATCHES "${CMAKE_SOURCE_DIR}/patches/*.patch")
if (PATCHES)
  message(STATUS "Patches: ${PATCHES}")
  foreach(PATCH ${PATCHES})
    message(STATUS "Applying ${PATCH}")
    execute_process(
      COMMAND patch -p1 --forward
      WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
      INPUT_FILE "${PATCH}"
      OUTPUT_VARIABLE OUTPUT
      RESULT_VARIABLE RESULT)
    if (RESULT EQUAL 0)
      message(STATUS "Patch applied: ${PATCH}")
    else()
      # Unfortunately although patch will recognise that a patch is already
      # applied it will still return an error.
      execute_process(
        COMMAND patch -p1 -R --dry-run
        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
        INPUT_FILE "${PATCH}"
        OUTPUT_VARIABLE OUTPUT
        RESULT_VARIABLE RESULT2)
      if (RESULT2 EQUAL 0)
        message(STATUS "Patch was already applied: ${PATCH}")
      else()
        message(FATAL_ERROR "Error applying patch ${PATCH}")
      endif()
    endif()
  endforeach(PATCH)
endif()


MARK_AS_ADVANCED(CLEAR CMAKE_INSTALL_PREFIX)
IF(APPLE)
  # CMake really likes finding libraries inside OS X frameworks. This can
  # create super unexpected results, such as the LDAP framework, where the
  # ldap.h header there just consists of "#include <ldap.h>" -- obviously
  # assuming /usr/include appears on the include path before that framework
  # (which wasn't really supposed to be on the include path at all). This
  # leads to a hilarious recursive include and general fireworks. Instead,
  # tell CMake to search frameworks *last*, if it doesn't find something in
  # /usr (or MacPorts/Homebrew).
  SET(CMAKE_FIND_FRAMEWORK "LAST")
  MARK_AS_ADVANCED(CMAKE_OSX_ARCHITECTURES
    CMAKE_OSX_DEPLOYMENT_TARGET
    CMAKE_OSX_SYSROOT)
ENDIF()

# Check architecture OS
IF(NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
  MESSAGE(FATAL_ERROR "HHVM requires a 64bit OS")
ENDIF()

# Enable ccache if present and not already enabled system wide.
option(SKIP_CCACHE "Skip detecting/enabling ccache - no effect if ccache enabled system wide" FALSE)
if(NOT SKIP_CCACHE)
  find_program(CCACHE_FOUND ccache)
  if(CCACHE_FOUND)
    if (NOT ("${CMAKE_CXX_COMPILER} ${CMAKE_C_COMPILER}" MATCHES ".*ccache.*"))
      set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_FOUND})
      message(STATUS "Found ccache: ${CCACHE_FOUND} - enabling ccache as compiler wrapper")
    else()
      message(STATUS "Found ccache - ccache already in use as C and/or CXX compiler wrapper")
   endif()
  endif(CCACHE_FOUND)
endif(NOT SKIP_CCACHE)

# 3rd party library
IF(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third-party/CMakeLists.txt")
  MESSAGE(FATAL_ERROR "third-party/CMakeLists.txt missing. "
                      "Try updating your submodule with:
rm -r third-party
git submodule update --init --recursive
")
ENDIF()

INCLUDE(HPHPFunctions)
INCLUDE(CheckFunctionExists)

SET(HPHP_HOME ${CMAKE_CURRENT_SOURCE_DIR})
SET(TP_DIR "${CMAKE_CURRENT_SOURCE_DIR}/third-party")
SET(TP_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}/third-party")

include(MSVCDefaults)
include(Options)
include(HPHPCompiler)
include(HPHPFindLibs)

ADD_SUBDIRECTORY(third-party)
ADD_SUBDIRECTORY(hphp)

# use GNU install dirs (e.g. lib64 instead of lib)
INCLUDE(GNUInstallDirs)

# modules / depends
FILE(GLOB HHVM_CMAKE_FILES "CMake/*.cmake")
INSTALL(
  FILES ${HHVM_CMAKE_FILES}
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/hhvm/CMake"
  COMPONENT dev)

=== third-party/CMakeLists.txt ===
#
#   +----------------------------------------------------------------------+
#   | HipHop for PHP                                                       |
#   +----------------------------------------------------------------------+
#   | Copyright (c) 2010 Facebook, Inc. (http://www.facebook.com)          |
#   | Copyright (c) 1997-2010 The PHP Group                                |
#   +----------------------------------------------------------------------+
#   | This source file is subject to version 3.01 of the PHP license,      |
#   | that is bundled with this package in the file LICENSE, and is        |
#   | available through the world-wide-web at the following url:           |
#   | http://www.php.net/license/3_01.txt                                  |
#   | If you did not receive a copy of the PHP license and are unable to   |
#   | obtain it through the world-wide-web, please send a note to          |
#   | license@php.net so we can mail you a copy immediately.               |
#   +----------------------------------------------------------------------+
#

set(EXTRA_INCLUDE_PATHS)
set(THIRD_PARTY_MODULES)
set(THIRD_PARTY_HEADERS)


list(APPEND THIRD_PARTY_MODULES libmbfl)
list(APPEND EXTRA_INCLUDE_PATHS
  "${TP_DIR}/libmbfl"
  "${TP_DIR}/libmbfl/mbfl"
  "${TP_DIR}/libmbfl/filters"
)

list(APPEND THIRD_PARTY_MODULES timelib)
list(APPEND EXTRA_INCLUDE_PATHS "${TP_DIR}/timelib")

list(APPEND THIRD_PARTY_MODULES folly)
list(APPEND EXTRA_INCLUDE_PATHS "${TP_DIR}/folly/src")

# Fatal is a header-only library, so there's nothing to build.
list(APPEND EXTRA_INCLUDE_PATHS "${TP_DIR}/fatal")

list(APPEND THIRD_PARTY_MODULES wangle)
list(APPEND EXTRA_INCLUDE_PATHS "${TP_DIR}/wangle/src")

list(APPEND THIRD_PARTY_MODULES brotli)
list(APPEND EXTRA_INCLUDE_PATHS "${TP_DIR}/brotli/src")

if(ENABLE_FASTCGI)
  list(APPEND THIRD_PARTY_MODULES proxygen)
  list(APPEND EXTRA_INCLUDE_PATHS "${TP_DIR}/proxygen/src")

  list(APPEND THIRD_PARTY_MODULES thrift)
  list(APPEND EXTRA_INCLUDE_PATHS "${TP_DIR}/thrift/src")

  list(APPEND THIRD_PARTY_MODULES zstd)
  list(APPEND EXTRA_INCLUDE_PATHS "${TP_DIR}/zstd/src/lib")
  list(APPEND EXTRA_INCLUDE_PATHS "${TP_DIR}/zstd/src/lib/dictBuilder")
endif()

if (NOT MSVC)
  list(APPEND THIRD_PARTY_MODULES libafdt)
  list(APPEND EXTRA_INCLUDE_PATHS "${TP_DIR}/libafdt/src/src")
endif()

if(ENABLE_ASYNC_MYSQL)
  find_package(RE2)
  if(NOT RE2_LIBRARY)
    message(STATUS "Building RE2 from third-party")
    list(APPEND THIRD_PARTY_MODULES re2)
  endif()
  list(APPEND THIRD_PARTY_MODULES squangle)
  list(APPEND THIRD_PARTY_MODULES webscalesqlclient)
endif()

if (ENABLE_MCROUTER)
  # Ragel is only used at build time to generate some files for MCRouter.
  list(APPEND THIRD_PARTY_MODULES ragel)

  list(APPEND THIRD_PARTY_MODULES mcrouter)
  list(APPEND EXTRA_INCLUDE_PATHS "${TP_DIR}/mcrouter/src")
endif()

# Add bundled fastlz if the system one will not be used
if(NOT FASTLZ_LIBRARY)
  list(APPEND THIRD_PARTY_MODULES fastlz)
  list(APPEND EXTRA_INCLUDE_PATHS "${TP_DIR}/fastlz/src")
endif()

# Add bundled libsqlite3 if the system one will not be used
if(NOT LIBSQLITE3_LIBRARY)
  list(APPEND THIRD_PARTY_MODULES libsqlite3)
  list(APPEND EXTRA_INCLUDE_PATHS "${TP_DIR}/libsqlite3")
endif()

# Add bundled lz4 if the system one will not be used
if(NOT LZ4_FOUND)
  list(APPEND THIRD_PARTY_MODULES lz4)
  list(APPEND EXTRA_INCLUDE_PATHS "${TP_DIR}/lz4/src/lib")
endif()

# Add bundled double-conversion if the system one will not be used
if(NOT DOUBLE_CONVERSION_FOUND)
  list(APPEND THIRD_PARTY_MODULES double-conversion)
  list(APPEND EXTRA_INCLUDE_PATHS "${TP_DIR}/double-conversion")
endif()

# Add bundled PCRE if the system one will not be used
find_package(PCRE)
if(NOT PCRE_LIBRARY)
  list(APPEND THIRD_PARTY_MODULES pcre)
  # Disable building a few parts of PCRE by default that we don't
  # actually use.
  set(PCRE_BUILD_PCRECPP OFF CACHE BOOL "Build the PCRE C++ library (pcrecpp).")
  set(PCRE_BUILD_PCREGREP OFF CACHE BOOL "Build pcregrep")
  set(PCRE_BUILD_TESTS OFF CACHE BOOL "Build the tests")
endif()

# Add bundled libzip if the system one will not be used
if(NOT LIBZIP_LIBRARY)
  list(APPEND THIRD_PARTY_MODULES libzip)
  list(APPEND EXTRA_INCLUDE_PATHS
    "${CMAKE_CURRENT_BINARY_DIR}/libzip/src/lib"
    "${TP_DIR}/libzip/src/lib"
  )
endif()

list(APPEND THIRD_PARTY_MODULES ocaml)

function(TP_INSTALL_HEADERS TARGET SRCDIR DEST)
  file(GLOB_RECURSE files "${SRCDIR}/*.h")
  install(
    CODE "INCLUDE(\"${HPHP_HOME}/CMake/HPHPFunctions.cmake\")
      HHVM_INSTALL_HEADERS(${TARGET}
      \"${CMAKE_CURRENT_SOURCE_DIR}/${SRCDIR}\"
      \"\${CMAKE_INSTALL_PREFIX}/include/hphp/third-party/${DEST}\"
      ${files})"
    COMPONENT dev)
endfunction()

foreach(MODULE ${THIRD_PARTY_MODULES})
  add_subdirectory(${MODULE})
  # Install headers here, rather than in the individual submodules, so that we
  # can easily control the destination. Put them in include/hphp/third-party.
  if(MODULE STREQUAL folly)
    TP_INSTALL_HEADERS(folly folly/src/folly folly)
  else()
    TP_INSTALL_HEADERS(${MODULE} ${MODULE} ${MODULE})
  endif()
endforeach()

if(NOT PCRE_LIBRARY)
  target_include_directories(pcre PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/pcre")
  target_compile_definitions(pcre PUBLIC "PCRE_STATIC=1")
endif()

set(THIRD_PARTY_INCLUDE_PATHS ${EXTRA_INCLUDE_PATHS} CACHE INTERNAL "" FORCE)

# boost checks
find_package(Boost 1.51.0 COMPONENTS context filesystem program_options regex system thread REQUIRED)
add_library(boost INTERFACE)
target_include_directories(boost INTERFACE ${Boost_INCLUDE_DIRS})
target_link_libraries(boost INTERFACE ${Boost_LIBRARIES})

=== hphp/compiler/CMakeLists.txt ===
set(SOURCE_SUBDIRS expression statement analysis system util parser)

set(CXX_SOURCES)
auto_sources(files "*.cpp" "${SOURCE_SUBDIRS}")
list(APPEND CXX_SOURCES ${files})

set(C_SOURCES)
auto_sources(files "*.c" "${SOURCE_SUBDIRS}")
list(APPEND C_SOURCES ${files})

set(HEADER_SOURCES)
auto_sources(files "*.h" "{$SOURCE_SUBDIRS}")
list(APPEND HEADER_SOURCES ${files})
HHVM_PUBLIC_HEADERS(compiler ${files})


set(ERROR_INC "analysis/core_code_error.inc")

set(ERROR_INC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/analysis/code_error.inc")

file(REMOVE "${ERROR_INC_FILE}")

file(WRITE "${ERROR_INC_FILE}" "/* This file is auto generated */")

foreach (error_file ${ERROR_INC})
  file(READ ${error_file} file_contents)

  file(APPEND "${ERROR_INC_FILE}" "${file_contents}")
endforeach (error_file ${ERROR_INC})

include_directories("${CMAKE_CURRENT_SOURCE_DIR}/../")

set(CMAKE_CURRENT_BINARY_DIR "${CMAKE_SOURCE_DIR}/bin")

foreach (CXX_FILE ${CXX_SOURCES})
  if(${CXX_FILE} MATCHES ".no.cpp$")
    SET_SOURCE_FILES_PROPERTIES(
      ${CXX_FILE}
      PROPERTIES
      COMPILE_FLAGS -O0
    )
  endif()
endforeach()

add_definitions(-DALWAYS_ASSERT=1)

ADD_LIBRARY(hphp_analysis STATIC ${CXX_SOURCES} ${C_SOURCES} ${HEADER_SOURCES})
auto_source_group("hphp_analysis" "${CMAKE_CURRENT_SOURCE_DIR}"
  ${CXX_SOURCES} ${C_SOURCES} ${HEADER_SOURCES})
target_link_libraries(hphp_analysis ${Boost_LIBRARIES})
add_dependencies(hphp_analysis hphp_parser)
if (ENABLE_COTIRE)
  cotire(hphp_analysis)
endif()

=== hphp/hack/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.7 FATAL_ERROR)

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../../CMake" ${CMAKE_MODULE_PATH})

option(BUILD_HACK "True if we should build the Hack typechecker." ON)

if (NOT BUILD_HACK)
  message(STATUS "Skipping hack")
  return()
endif()

message(STATUS "Building hack")

if ("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_LIST_DIR}")
  set(HACK_ONLY_BUILD TRUE)
endif()

if (HACK_ONLY_BUILD)
  # Woah - this is special. They're running cmake in the hack directory
  # itself so we don't have our usual set up.
  get_filename_component(HPHP_HOME "${CMAKE_CURRENT_LIST_DIR}/../.." ABSOLUTE)
  set(TP_DIR "${HPHP_HOME}/third-party")
  set(TP_BUILD_DIR ${TP_DIR})

  if(NOT EXISTS "${TP_DIR}/CMakeLists.txt")
    message(FATAL_ERROR
      "${TP_DIR}/CMakeLists.txt missing. Try updating your submodule with:\n"
      "    rm -r ${TP_DIR}\n"
      "    git submodule update --init --recursive\n"
      )
  endif()
endif()

find_package(LZ4)
find_package(LibElf)

if (HACK_ONLY_BUILD AND NOT LZ4_FOUND)
  add_subdirectory("${TP_DIR}/lz4" "${TP_DIR}/lz4")
endif()

if (HACK_ONLY_BUILD AND NOT OCAML_FOUND)
  add_subdirectory("${TP_DIR}/ocaml" "${TP_DIR}/ocaml")
endif()

if (HACK_ONLY_BUILD AND NOT PC_SQLITE3_FOUND)
  add_subdirectory("${TP_DIR}/libsqlite3" "${TP_DIR}/libsqlite3")
endif()

# This is totally the wrong way to do this, but I am tired of fighting with
# build systems and don't really care to make this work the right way. libelf,
# lz4 and sqlite3 all we need right now anyways.
unset(extra_include_paths)
unset(extra_lib_paths)
unset(extra_cc_flags)

# Allows '#include "hphp/path/to/library/"' paths to start from hphp
# project directory  which is consistent with fbmake's include paths.

IF(HPHP_HOME)
  list(APPEND extra_include_paths ${HPHP_HOME})
ELSE()
  list(APPEND extra_include_paths ${CMAKE_CURRENT_SOURCE_DIR}/../..)
ENDIF()

foreach(lib ${LIBELF_INCLUDE_DIRS})
  list(APPEND extra_include_paths ${lib})
endforeach()
if(ELF_GETSHDRSTRNDX)
  list(APPEND extra_cc_flags -DHAVE_ELF_GETSHDRSTRNDX)
endif()

list(APPEND extra_cc_flags -pthread)

foreach(lib ${LIBELF_LIBRARIES})
  get_filename_component(pth ${lib} PATH)
  list(APPEND extra_lib_paths ${pth})
endforeach()

if(LZ4_FOUND)
  list(APPEND extra_include_paths ${LZ4_INCLUDE_DIR})
  get_filename_component(pth ${LZ4_LIBRARY} PATH)
  list(APPEND extra_lib_paths ${pth})
  list(APPEND extra_native_libraries "lz4")
else()
  list(APPEND extra_include_paths "${TP_DIR}/lz4/src/lib")
  # If LZ4_FOUND is false either we didn't find lz4 or we found it but it's the
  # wrong version.  We can't just add the new path and a native_lib because we
  # can't control the order (and -l won't accept the raw path to the lib).  By
  # doing it this way we specify the path explicitly.
  list(APPEND extra_link_opts "$<TARGET_LINKER_FILE:lz4>")
endif()

if(PC_SQLITE3_FOUND)
  list(APPEND extra_include_paths ${LIBSQLITE3_INCLUDE_DIR})
  get_filename_component(pth ${LIBSQLITE3_LIBRARY} PATH)
  list(APPEND extra_lib_paths ${pth})
else()
  list(APPEND extra_include_paths "${TP_DIR}/libsqlite3")
  list(APPEND extra_lib_paths "${TP_BUILD_DIR}/libsqlite3")
endif()
list(APPEND extra_native_libraries "sqlite3")

# Xcode/Ninja generators undefined MAKE
if(NOT MAKE)
  set(MAKE make)
endif()

add_custom_target(
  hack
  ALL
  COMMAND
        $(MAKE) EXTRA_INCLUDE_PATHS="${extra_include_paths}"
        EXTRA_LIB_PATHS="${extra_lib_paths}"
        EXTRA_LINK_OPTS="${extra_link_opts}"
        EXTRA_CC_FLAGS="${extra_cc_flags}"
        EXTRA_NATIVE_LIBRARIES="${extra_native_libraries}"
        BYTECODE="${EMIT_OCAML_BYTECODE}"
        OCAML="${OCAML_EXECUTABLE}"
        OCAMLC="${OCAMLC_EXECUTABLE}"
        OCAMLBUILD="${OCAMLBUILD_EXECUTABLE}"
        OCAMLBUILD_FLAGS="-ocamlc=${OCAMLC_EXECUTABLE},-ocamlopt=${OCAMLOPT_EXECUTABLE}"
  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/src"
)
add_dependencies(hack ocaml)

add_custom_target(
  hack_test
  COMMAND
        $(MAKE) test EXTRA_INCLUDE_PATHS="${extra_include_paths}"
        EXTRA_LIB_PATHS="${extra_lib_paths}"
        EXTRA_LINK_OPTS="${extra_link_opts}"
        EXTRA_CC_FLAGS="${extra_cc_flags}"
        EXTRA_NATIVE_LIBRARIES="${extra_native_libraries}"
        BYTECODE="${EMIT_OCAML_BYTECODE}"
        OCAML="${OCAML_EXECUTABLE}"
        OCAMLC="${OCAMLC_EXECUTABLE}"
        OCAMLBUILD="${OCAMLBUILD_EXECUTABLE}"
        OCAMLBUILD_FLAGS="-ocamlc=${OCAMLC_EXECUTABLE},-ocamlopt=${OCAMLOPT_EXECUTABLE}"
  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/src"
)
add_dependencies(hack_test ocaml)

if(NOT LZ4_FOUND)
  # if the system does not have lz4, make sure that the one in public_tl
  # gets built
  add_dependencies(hack lz4)
  add_dependencies(hack_test lz4)
endif()

if(NOT PC_SQLITE3_FOUND)
  # if the system does not have sqlite3, make sure that the one in public_tl
  # gets built
  add_dependencies(hack sqlite3)
  add_dependencies(hack_test sqlite3)
endif()

install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hh_client
  DESTINATION bin
  COMPONENT dev)

install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hh_server
  DESTINATION bin
  COMPONENT dev)

install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hackfmt
  DESTINATION bin
  COMPONENT dev)

install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hh_format
  DESTINATION bin
  COMPONENT dev)

install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hh_parse
  DESTINATION bin
  COMPONENT dev)

=== hphp/hhbbc/CMakeLists.txt ===
set(CXX_SOURCES)
auto_sources(files "*.cpp" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND CXX_SOURCES ${files})

set(HEADER_SOURCES)
auto_sources(files "*.h" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND HEADER_SOURCES ${files})
HHVM_PUBLIC_HEADERS(hhbc ${files})


# remove anything in a test folder
HHVM_REMOVE_MATCHES_FROM_LISTS(CXX_SOURCES HEADER_SOURCES MATCHES "/test/")

add_library(hphp_hhbbc STATIC ${CXX_SOURCES} ${HEADER_SOURCES})
auto_source_group("hphp_hhbbc" "${CMAKE_CURRENT_SOURCE_DIR}"
  ${CXX_SOURCES} ${HEADER_SOURCES})
add_dependencies(hphp_hhbbc hphp_system)
if (ENABLE_COTIRE)
  cotire(hphp_hhbbc)
endif()

=== hphp/hhvm/CMakeLists.txt ===
include(HHVMExtensionConfig)

set(CXX_SOURCES)
auto_sources(files "*.cpp" "")
list(APPEND CXX_SOURCES ${files})

# Windows targets use a generated rc file for embedding libraries
if(MSVC)
  list(APPEND CXX_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/embed.rc)
endif()

option(ENABLE_LD_GOLD "Enable Hot Linker script using ld-gold" On)
set(SECTION_ORDERING_FILE ${CMAKE_CURRENT_SOURCE_DIR}/../tools/oss_hot_section_ordering CACHE FILEPATH "File used by ld-gold for the relocation of sections")
if (ENABLE_LD_GOLD)
  find_package(Gold)
endif()

get_object_libraries_objects(additionalObjects ${HHVM_WHOLE_ARCHIVE_LIBRARIES})
add_executable(hhvm ${CXX_SOURCES} ${additionalObjects})
target_link_libraries(hhvm ${HHVM_LINK_LIBRARIES} ${EZC_LINK_LIBRARIES} ${HRE_LINK_LIBRARIES})
link_object_libraries(hhvm ${HHVM_WHOLE_ARCHIVE_LIBRARIES})
if (GOLD_FOUND AND ENABLE_LD_GOLD)
  if (CMAKE_CONFIGURATION_TYPES)
    SET(LINKER_SCRIPT -fuse-ld=gold;-Wl,--icf=all,--gc-sections;release;-Wl,--section-ordering-file,${SECTION_ORDERING_FILE};default)
  elseif(NOT CMAKE_BUILD_TYPE MATCHES "Debug")
    SET(LINKER_SCRIPT -fuse-ld=gold -Wl,--section-ordering-file,${SECTION_ORDERING_FILE},--icf=all,--gc-sections)
  else()
    SET(LINKER_SCRIPT -fuse-ld=gold -Wl,--icf=all,--gc-sections)
  endif()
  target_link_libraries(hhvm ${LINKER_SCRIPT})
endif()
hphp_link(hhvm)
HHVM_CONFIGURE_TARGET_FOR_EXTENSION_DEPENDENCIES(hhvm)

if (ENABLE_SPLIT_DWARF)
  if (NOT GOLD_FOUND)
    message(FATAL_ERROR "ENABLE_SPLIT_DWARF was specified but the gold linker was not found")
  endif()
  message(STATUS "Enabled split DWARF files")
  target_link_libraries(hhvm debug "-Wl,--gdb-index")
endif()

# Check whether atomic operations require -latomic or not
# See https://github.com/facebook/hhvm/issues/5217
INCLUDE(CheckCXXSourceCompiles)
set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
set(CMAKE_REQUIRED_FLAGS "-std=c++1y")
CHECK_CXX_SOURCE_COMPILES("
#include <atomic>
int main() {
    struct Test { int val; };
    std::atomic<Test> s;
    s.is_lock_free();
}
" NOT_REQUIRE_ATOMIC_LINKER_FLAG)

if(NOT "${NOT_REQUIRE_ATOMIC_LINKER_FLAG}")
    message(STATUS "-latomic is required to link hhvm")
    target_link_libraries(hhvm atomic)
endif()
set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})

embed_all_systemlibs(hhvm "${CMAKE_CURRENT_BINARY_DIR}/.." "${CMAKE_CURRENT_BINARY_DIR}/hhvm")
add_dependencies(hhvm systemlib)

if (CMAKE_HOST_UNIX)
  add_custom_command(TARGET hhvm POST_BUILD
    COMMAND INSTALL_DIR=${CMAKE_CURRENT_BINARY_DIR} sh ${CMAKE_CURRENT_SOURCE_DIR}/symlinks.sh ${CMAKE_CURRENT_BINARY_DIR}/hhvm
    COMMENT "Creating symlinks for hhvm")
endif()

if (ENABLE_COTIRE)
  cotire(hhvm)
endif()

HHVM_INSTALL(hhvm bin)

auto_sources(files "*.h" "")
HHVM_PUBLIC_HEADERS(hhvm ${files})

=== hphp/ppc64-asm/CMakeLists.txt ===
set(CXX_SOURCES)
set(HEADER_SOURCES)

auto_sources(files "*.cpp" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND CXX_SOURCES ${files})
auto_sources(files "*.h" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND HEADER_SOURCES ${files})

add_library(ppc64-asm STATIC ${HEADERS_SOURCES} ${CXX_SOURCES})

HHVM_PUBLIC_HEADERS(ppc64-asm ${HEADERS_SOURCES})

=== hphp/runtime/CMakeLists.txt ===
include(HHVMExtensionConfig)

set(RECURSIVE_SOURCE_SUBDIRS base debugger eval server vm)
foreach (dir ${RECURSIVE_SOURCE_SUBDIRS})
  HHVM_SELECT_SOURCES("${CMAKE_CURRENT_SOURCE_DIR}/${dir}")
endforeach(dir ${RECURSIVE_SOURCE_SUBDIRS})
list(APPEND HEADER_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/version.h")

if(NOT LINUX)
  list(REMOVE_ITEM CXX_SOURCES
       ${CMAKE_CURRENT_SOURCE_DIR}/vm/debug/elfwriter.cpp)
  list(REMOVE_ITEM HEADER_SOURCES
       ${CMAKE_CURRENT_SOURCE_DIR}/vm/debug/elfwriter.h)
endif()

if(NOT ENABLE_FASTCGI)
  HHVM_REMOVE_MATCHES_FROM_LISTS(CXX_SOURCES HEADER_SOURCES
    MATCHES "/fastcgi/")
endif()

if(NOT ENABLE_PROXYGEN_SERVER)
  HHVM_REMOVE_MATCHES_FROM_LISTS(CXX_SOURCES HEADER_SOURCES
    MATCHES "/proxygen/")
endif()

if(NOT HAVE_CUSTOM_LIBEVENT)
  HHVM_REMOVE_MATCHES_FROM_LISTS(CXX_SOURCES HEADER_SOURCES
    MATCHES "/server/libevent-")
endif()

add_custom_command(
  OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/ir-opcode-generated.h"
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/../doc/generate-ir-opcodes.sh"
  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/../doc/ir.specification"
          "${CMAKE_CURRENT_SOURCE_DIR}/../doc/generate-ir-opcodes.pl"
          "${CMAKE_CURRENT_SOURCE_DIR}/../doc/generate-ir-opcodes.sh"
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMENT "Generating HHIR opcode table"
  VERBATIM)

add_precompiled_header(
  "${HPHP_HOME}/hphp/pch/hphp_runtime_static.h"
  "${HPHP_HOME}/hphp/pch/hphp_runtime_static.cpp"
  CXX_SOURCES
)

add_object_library(hphp_runtime_static
            ${CXX_SOURCES} ${C_SOURCES} ${ASM_SOURCES} ${HEADER_SOURCES}
            "ir-opcode-generated.h")
auto_source_group("hphp_runtime_static" "${CMAKE_CURRENT_SOURCE_DIR}"
  ${ASM_SOURCES} ${C_SOURCES} ${CXX_SOURCES} ${HEADER_SOURCES})
SET_TARGET_PROPERTIES(hphp_runtime_static PROPERTIES OUTPUT_NAME "hphp_runtime")
SET_TARGET_PROPERTIES(hphp_runtime_static PROPERTIES PREFIX "lib")
SET_TARGET_PROPERTIES(hphp_runtime_static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
object_library_hphp_link(hphp_runtime_static)
object_library_ld_link_libraries(hphp_runtime_static hphp_util hphp_proxygen vixl ppc64-asm hphp_zend hphp_system jit_sort)
HHVM_CONFIGURE_TARGET_FOR_EXTENSION_DEPENDENCIES(hphp_runtime_static)

SET(CMAKE_CXX_ARCHIVE_APPEND "<CMAKE_AR> q <TARGET> <LINK_FLAGS> <OBJECTS>")

HHVM_PUBLIC_HEADERS(runtime ${HEADER_SOURCES})

if (ENABLE_COTIRE)
  cotire(hphp_runtime_static)
endif()

set(EZC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../runtime/ext_zend_compat/")
include_directories("${EZC_DIR}/php-src")
include_directories("${EZC_DIR}/php-src/main")
include_directories("${EZC_DIR}/php-src/Zend")
include_directories("${EZC_DIR}/php-src/TSRM")

=== hphp/system/CMakeLists.txt ===
set(CXX_SOURCES "systemlib.cpp")

add_library(hphp_system STATIC ${CXX_SOURCES})
if (ENABLE_ASYNC_MYSQL)
  add_dependencies(hphp_system webscalesqlclient)
endif ()

auto_sources(files "*.h" "${CMAKE_CURRENT_SOURCE_DIR}")
HHVM_PUBLIC_HEADERS(system ${files})

if (ENABLE_ZEND_COMPAT)
  add_dependencies(hphp_ext_zend_compat hphp_system)
endif()

add_dependencies(hphp_runtime_static hphp_system)
add_dependencies(hphp_runtime_ext hphp_system)
add_dependencies(hphp_analysis hphp_system)

FILE(STRINGS "php.txt" SYSTEMLIB_CLASSES)
set(SYSTEMLIB_SRCS)
set(SYSTEMLIB_SRCS_STR)
foreach(cls ${SYSTEMLIB_CLASSES})
  STRING(REGEX REPLACE "[ \t]*#.*" "" cls "${cls}")
  if (NOT "${cls}" STREQUAL "")
    list(APPEND SYSTEMLIB_SRCS "../../${cls}")
    set(SYSTEMLIB_SRCS_STR "${SYSTEMLIB_SRCS_STR} ${cls}")
  endif()
endforeach()

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/systemlib.php
  DEPENDS "php.txt" ${SYSTEMLIB_SRCS}
  COMMAND "INSTALL_DIR=${CMAKE_CURRENT_BINARY_DIR}"
          "FBCODE_DIR=${CMAKE_CURRENT_SOURCE_DIR}/../.."
          "${CMAKE_CURRENT_SOURCE_DIR}/make_systemlib.sh"
          "--install_dir=${CMAKE_CURRENT_BINARY_DIR}"
          "--fbcode_dir=${CMAKE_CURRENT_SOURCE_DIR}/.."
          "${SYSTEMLIB_SRCS_STR}"
  COMMENT "Generating systemlib.php")

add_custom_target(
  systemlib
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/systemlib.php)

=== hphp/test/CMakeLists.txt ===
set(CXX_SOURCES)
add_definitions("-DHHVM_PATH=\"${CMAKE_CURRENT_SOURCE_DIR}/../hhvm/hhvm\"")

set(RECURSIVE_SOURCE_SUBDIRS ext)
foreach (dir ${RECURSIVE_SOURCE_SUBDIRS})
  auto_sources(files "*.cpp" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}/${dir}")
  list(APPEND CXX_SOURCES ${files})
endforeach(dir ${RECURSIVE_SOURCE_SUBDIRS})

list(APPEND CXX_SOURCES ${files})
list(APPEND CXX_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/../hhvm/process-init.cpp")

if(NOT HAVE_CUSTOM_LIBEVENT)
  list(REMOVE_ITEM CXX_SOURCES
       "${CMAKE_CURRENT_SOURCE_DIR}/ext/test_ext_curl.cpp")
endif()

add_executable(test ${CXX_SOURCES})
target_link_libraries(test ${HHVM_LINK_LIBRARIES})
embed_all_systemlibs(test "${CMAKE_CURRENT_BINARY_DIR}/.." "${CMAKE_CURRENT_BINARY_DIR}/test")
add_dependencies(test systemlib)
if (ENABLE_COTIRE)
  cotire(test)
endif()

=== hphp/util/CMakeLists.txt ===
set(CXX_SOURCES)
auto_sources(files "*.cpp" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND CXX_SOURCES ${files})

set(ASM_SOURCES)
auto_sources(files "*.S" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND ASM_SOURCES ${files})

set(HEADER_SOURCES)
auto_sources(files "*.h" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND HEADER_SOURCES ${files})

# Disable Channeled JSON until we're sure it's going to stick
# sgolemon(2014-02-19)
HHVM_REMOVE_MATCHES_FROM_LISTS(ASM_SOURCES CXX_SOURCES HEADER_SOURCES
  MATCHES "/test/" "channeled-json-")

if (NOT MSVC)
  list(REMOVE_ITEM CXX_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/fnmatch.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/glob.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/rand_r.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/strfmon.cpp
  )
  list(REMOVE_ITEM HEADER_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/fnmatch.h
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/glob.h
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/rand_r.h
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/strfmon.h
  )
endif()

HHVM_PUBLIC_HEADERS(util ${HEADER_SOURCES})

find_package(LibNuma)
if (LIBNUMA_INCLUDE_DIRS)
  add_definitions("-DHAVE_NUMA=1")
  include_directories(${LIBNUMA_INCLUDE_DIRS})
endif()

if(MSVC)
  list(REMOVE_ITEM CXX_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/afdt-util.cpp")
  list(REMOVE_ITEM HEADER_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/afdt-util.h")
  list(REMOVE_ITEM CXX_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/light-process.cpp")
  list(REMOVE_ITEM HEADER_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/light-process.h")
endif()

add_library(hphp_util STATIC ${CXX_SOURCES} ${ASM_SOURCES} ${HEADER_SOURCES})
auto_source_group("hphp_util" "${CMAKE_CURRENT_SOURCE_DIR}"
  ${ASM_SOURCES} ${CXX_SOURCES} ${HEADER_SOURCES})
if (ENABLE_COTIRE)
  cotire(hphp_util)
endif()

if (LIBNUMA_LIBRARIES)
  target_link_libraries(hphp_util ${LIBNUMA_LIBRARIES})
endif()
if (ENABLE_ASYNC_MYSQL)
  add_dependencies(hphp_util webscalesqlclient)
endif ()

=== third-party/brotli/CMakeLists.txt ===
set(BROTLI_ENC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src/enc")
set(BROTLI_DEC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src/dec")

auto_sources(enc_ccfiles "*.cc" "RECURSE" "${BROTLI_ENC_DIR}")
auto_sources(enc_cfiles "*.c" "RECURSE" "${BROTLI_ENC_DIR}")
auto_sources(enc_hfiles "*.h" "RECURSE" "${BROTLI_ENC_DIR}")

auto_sources(dec_ccfiles "*.cc" "RECURSE" "${BROTLI_DEC_DIR}")
auto_sources(dec_cfiles "*.c" "RECURSE" "${BROTLI_DEC_DIR}")
auto_sources(dec_hfiles "*.h" "RECURSE" "${BROTLI_DEC_DIR}")

add_library(brotli_enc STATIC ${enc_ccfiles} ${enc_cfiles} ${enc_hfiles})
auto_source_group(brotli_enc ${BROTLI_ENC_DIR} ${enc_ccfiles} ${enc_cfiles} ${enc_hfiles})
target_include_directories(brotli_enc PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/src")

add_library(brotli_dec STATIC ${dec_ccfiles} ${dec_cfiles} ${dnc_hfiles})
auto_source_group(brotli_dec ${BROTLI_DEC_DIR} ${dec_ccfiles} ${dec_cfiles} ${dec_hfiles})
target_include_directories(brotli_dec PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/src")

=== debian/changelog ===
hhvm (3.21.0+dfsg-2ubuntu2) bionic; urgency=medium

  * Build-depend on libcurl4-gnutls-dev instead, which is the default
    implementation and lets us continue building against libssl1.0-dev, as
    the source is not OpenSSL 1.1-compatible.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2018 22:06:09 +0000

hhvm (3.21.0+dfsg-2ubuntu1) bionic; urgency=medium

  * Build-depend on libssl-dev again instead of libssl1.0-dev and re-add
    build-dependency on libc-client2007e-dev.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2018 21:17:58 +0000

hhvm (3.21.0+dfsg-2build5) bionic; urgency=medium

  * No-change rebuild against libcurl4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2018 06:56:58 +0000

hhvm (3.21.0+dfsg-2build4) bionic; urgency=medium

  * No change rebuild against libre2-4.

 -- Stefano Rivera <stefanor@ubuntu.com>  Fri, 23 Feb 2018 15:07:17 -0800

hhvm (3.21.0+dfsg-2build3) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 06 Feb 2018 12:42:49 +0000

hhvm (3.21.0+dfsg-2build2) bionic; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Nov 2017 08:52:54 +0000

hhvm (3.21.0+dfsg-2build1) bionic; urgency=medium

  * No-change rebuild for libicu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 25 Oct 2017 15:40:34 +0000

hhvm (3.21.0+dfsg-2) unstable; urgency=medium

  * Fix compatibility with glibc 2.26, thanks to Matthias Klose for
    the report (Closes: #875904)

 -- Moritz Muehlenhoff <jmm@debian.org>  Wed, 27 Sep 2017 16:25:21 +0200

hhvm (3.21.0+dfsg-1) unstable; urgency=medium

  * New upstream release 3.21 (3.18 releases were not
    uploaded to the archive due to various stability
    problems)
  * Fix FTBFS with GCC 7 (Closes: #853442)
  * Back out broken upstream JSON test case (reported at
    https://github.com/facebook/hhvm/issues/7708)
  * Add ocamlbuild to build dependencies (reported in #868480,
    compatibility of 3.21 with ocaml 4.05 needs to be revisited)
  * Update copyright file for 3.12->3.21 period, taking most of
    the entries for webscalesqlclient from src:mysql-5.6's copyright
    file
  * Remove Upstart job
  * Bump standards version

 -- Moritz Muehlenhoff <jmm@debian.org>  Mon, 07 Aug 2017 21:55:59 +0200

hhvm (3.18.1+dfsg-1) unstable; urgency=medium

  [ Faidon Liambotis ]
  * New upstream release 3.17.0+dfsg
  * Remove patches merged upstream:
    - libc6-223-isnan.patch
    - gcc6.patch
    - disable-folly-fibers.patch
    - pcre-838-limits.patch
    - pcre-disable-limit-test.patch
    - mysqlclient-r.patch
    - fix_stats_error.patch
    - output-buffer-fix-flush.patch
    - revert-unbreak-jsonc.patch
    - icu-getsortkey.patch
    - bzip2-segfault-sweep.patch
    - reproducible-proxygen-header.patch
  * Remove patches for code that was reworked upstream:
    - reproducible-hack-builddate.patch
    - reproducible-hack-compilerid.patch
  * Depend on ragel:
    - Add ragel to Build-Depends.
    - Remove ragel from third-party when repacking (debian/repack)
    - Add patch use-system-ragel.patch.
  * Add new third-party bundles brotli and fatal to debian/copyright.
  * Re-enable the mcrouter extension as it should build again now.

  [ Moritz Muehlenhoff ]
  * New upstream release 3.18.1+dfsg
  * Add missing build-dependency on libkrb5-dev
  * Add a versioned dependeny on lz4 >= 130, the lz4 extension in 3.18
    uses the new LZ4_compress_default() function introduced there
  * No longer strip webscalesqlclient from dfsg tarball, with 3.18 the
    mysql extension requires it as well (transivitely via squangle,
    which in turn depends on webscalesql)
  * Add build dependency on libreadline-dev, required by webscalesqlclient
  * Reenable asynchronous MySQL support now that we're using webscalesqlclient
    again (even when adding webscalesqlclient back to the source try, squangle
    is only linked with DENABLE_ASYNC_MYSQL=ON, IOW DENABLE_ASYNC_MYSQL=OFF is
    entirely broken
  * Cherrypick f7a1dae3d90179c10c03e749875aa8a6a5015605 from upstream
    master to fix testsuite failure with DUSE_JSONC=ON
  * Run testsuite in LC_ALL=C.UTF-8, one of the tests is
    locale-sensitive (https://github.com/facebook/hhvm/issues/7708)
  * Cherrypick 5207b59eb88e2f9820efb74442245a4f5aa9eb17 from upstream
    master to fix crashes with hhvm.server.stat_cache enabled
  * Add myself to Uploaders

 -- Moritz Muehlenhoff <mmuhlenhoff@wikimedia.org>  Wed, 05 Apr 2017 09:46:19 +0200

=== debian/control ===
Source: hhvm
Section: php
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian HHVM packaging team <pkg-hhvm-team@lists.alioth.debian.org>
Uploaders: Faidon Liambotis <paravoid@debian.org>, Moritz Muehlenhoff <jmm@debian.org>
Build-Depends: debhelper (>= 9.0.0),
  autotools-dev,
  binutils-dev,
  bison,
  chrpath,
  cmake,
  default-libmysqlclient-dev | libmysqlclient-dev,
  flex,
  gawk,
  gperf,
  libboost-dev,
  libboost-context-dev,
  libboost-filesystem-dev,
  libboost-program-options-dev,
  libboost-regex-dev,
  libboost-system-dev,
  libboost-thread-dev,
  libbz2-dev,
  libcap-dev,
#  libc-client2007e-dev,
  libcurl4-gnutls-dev,
  libdouble-conversion-dev,
  libdwarf-dev,
  libedit-dev,
  libelf-dev,
  libevent-dev,
  libexpat1-dev,
  libfreetype6-dev,
  libgmp-dev,
  libgoogle-glog-dev,
  libiberty-dev,
  libicu-dev,
  libinotifytools0-dev,
  libjemalloc-dev,
  libjpeg-dev,
  libjson-c-dev,
  libkrb5-dev,
  libldap2-dev,
  liblz4-dev (>= 0.0~r130),
  libmagickcore-dev,
  libmagickwand-dev,
  libmcrypt-dev,
  libmemcached-dev,
  libonig-dev,
  libpcre3-dev,
  libpng-dev,
  libreadline-dev,
  libre2-dev,
  libsqlite3-dev,
  libssl1.0-dev | libssl-dev (<< 1.1),
  libtbb-dev,
  libvpx-dev,
  libxml2-dev,
  libxslt1-dev,
  libyaml-dev,
  libzip-dev (>= 0.11),
  ocamlbuild  | ocaml-nox (<< 4.05),
  ocaml-native-compilers,
  pkg-config,
  ragel,
  unixodbc-dev,
  zlib1g-dev
Standards-Version: 4.0.1
Homepage: http://hhvm.com/
Vcs-Git: https://anonscm.debian.org/git/pkg-hhvm/hhvm.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-hhvm/hhvm.git

Package: hhvm
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: ${hhvm:ApiVersion}
Description: HipHop Virtual Machine, a JIT replacement for PHP - main runtime
 HHVM is an open-source virtual machine designed for executing programs
 written in Hack and PHP. HHVM uses a just-in-time (JIT) compilation
 approach to achieve superior performance while maintaining the development
 flexibility that PHP provides.
 .
 For the majority of your programs HHVM should be a drop-in replacement for
 the usual PHP interpreter/engine.

Package: hhvm-dbg
Architecture: amd64
Depends: hhvm (= ${binary:Version}), python, ${misc:Depends}
Recommends: gdb
Section: debug
Priority: extra
Description: HipHop Virtual Machine, a JIT replacement for PHP - debugging symbols
 HHVM is an open-source virtual machine designed for executing programs
 written in Hack and PHP. HHVM uses a just-in-time (JIT) compilation
 approach to achieve superior performance while maintaining the development
 flexibility that PHP provides.
 .
 For the majority of your programs HHVM should be a drop-in replacement for
 the usual PHP interpreter/engine.
 .
 This package provides the debugging symbols for HHVM.

Package: hhvm-dev
Architecture: amd64
Depends: ${misc:Depends}, cmake
Section: libdevel
Priority: extra
Description: HipHop Virtual Machine, a JIT replacement for PHP - development files
 HHVM is an open-source virtual machine designed for executing programs
 written in Hack and PHP. HHVM uses a just-in-time (JIT) compilation
 approach to achieve superior performance while maintaining the development
 flexibility that PHP provides.
 .
 For the majority of your programs HHVM should be a drop-in replacement for
 the usual PHP interpreter/engine.
 .
 This package provides the header & build system files needed for compiling
 HHVM extensions.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

# To prevent bogus linkage.
LDFLAGS += -Wl,--as-needed

# avoid FTBFS with GCC 6 due to translator-asm-helpers.S not being PIC
# might be fixed with commit 8b6c9f4 in HHVM 3.14
ifneq ($(shell $(CC) -dumpspecs 2>/dev/null | grep -e no-pie),)
  CFLAGS  += -fno-pie
  LDFLAGS += -no-pie
endif

# used to store HHBC during tests
BUILDHOME = $(CURDIR)/debian/build

# Exported variable to make sure that we don't use cursor control in the tests.
export TRAVIS = bogus

# Contrary to its confusing name, this is actually the build's revision ID.
# hphp/util/generate-buildinfo.sh uses:
#   $COMPILER_ID -> git describe -> hg log -> date
# We want to avoid relying on git (because we may building from the .dsc) and
# date (because that would add variance to the build)
export COMPILER_ID = $(shell dpkg-parsechangelog -SVersion)

# same with the repo schema, which uniquely identifies a build; the script
# takes some variance into account, possibly from CMakeFiles; it also operates
# differently when under git, so make it just a hash of the Debian version.
export HHVM_REPO_SCHEMA = $(shell dpkg-parsechangelog -SVersion | sha1sum | cut -b-40)

%:
	dh $@ --parallel

override_dh_auto_build:
	# rerun flex/bison to regenerate their output for DFSG reasons
	cd hphp/parser/ && \
		./make-lexer.sh && \
		./make-parser.sh
	VERBOSE=1 dh_auto_build

override_dh_auto_configure:
	printenv
	echo $(LDFLAGS)
	dh_auto_configure -- \
		-DUSE_JSONC=ON \
		-DFREETYPE_INCLUDE_DIRS=/usr/include/freetype2/ \
		-DENABLE_ASYNC_MYSQL=ON \
		-DMYSQL_UNIX_SOCK_ADDR=/dev/null \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	# HHVM by default uses ~/.hhvm.hhbc, but ~ isn't guranteed to exist.
	-mkdir $(BUILDHOME)
	LC_ALL=C.UTF-8 HOME=$(BUILDHOME) hphp/hhvm/hhvm hphp/test/run -m jit quick
	LC_ALL=C.UTF-8 HOME=$(BUILDHOME) hphp/hhvm/hhvm hphp/test/run -m interp quick
endif

override_dh_clean:
	dh_clean
	-rm -rf $(BUILDHOME)

override_dh_gencontrol:
	# see hphp/runtime/version.h, HHVM_VERSION_BRANCH
	hhvmapi=$(shell $(CURDIR)/debian/hhvm/usr/bin/hhvm --version | sed -ne 's/^HipHop VM \(.*\)\..*/\1/p') && \
		[ -n "$${hhvmapi}" ] && echo "hhvm:ApiVersion=hhvm-api-$${hhvmapi}" >> debian/hhvm.substvars
	dh_gencontrol

override_dh_strip:
	dh_strip --dbg-package=hhvm-dbg

override_dh_fixperms:
	dh_fixperms
	chown www-data:www-data \
		$(CURDIR)/debian/hhvm/var/cache/hhvm

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg.*$//,\
filenamemangle=s/(?:.*)?v?HHVM-(\d[\d\.]*)\.tar\.gz/hhvm-$1.tar.gz/ \
  https://github.com/facebook/hhvm/tags \
  (?:.*/)?v?HHVM-(\d[\d\.]*)\.tar\.gz
